////////////////////////////////////////////////////////////////////////////////
// Big Apple Hot Dogs Section Navigation
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------
// Constructor
//------------------------------------------------
bigapple.views.main.SectionNav = function() {
	this.init();
	return this;
};

bigapple.views.main.SectionNav.prototype = (function() {
	
	var _public = {
		//------------------------------------------------
		// Init
		//------------------------------------------------
		init:function() {
			_private.setup();
		}
	};
	
	var _private = {
		//------------------------------------------------
		// Variables
		//------------------------------------------------
		SCROLL_DURATION: 800,
		
		//------------------------------------------------
		// Set up nav
		//------------------------------------------------
		setup:function() {
			this.createListeners();
		},
		
		//------------------------------------------------
		// Listen for mouse events
		//------------------------------------------------
		createListeners:function() {
			$('.section-nav .next a').bind("click", function(e) {_private.onNextButtonClicked(e);});
			$('.section-nav .previous a').bind("click", function(e) {_private.onPreviousButtonClicked(e);});
			$('#section-nav a').bind("click", function(e) {_private.onMainNavClicked(e);});
		},
		
		//------------------------------------------------
		// Scroll to a section by ID
		//------------------------------------------------
		scrollToSection:function(sectionID) {
			var sectionOffset = $('.section:eq(' + sectionID + ')').offset();
			var targetY = sectionOffset.top;
			$(this.getScrollTarget()).stop().animate({scrollTop: targetY}, this.SCROLL_DURATION, "easeInOutQuad");
		},
		
		//------------------------------------------------
		// Find which element to scroll
		//------------------------------------------------
		getScrollTarget:function() {
			return $("body, html");
		},
		
		//------------------------------------------------
		// Scroll to next section
		//------------------------------------------------
		onNextButtonClicked:function(e) {
			var sectionID = $('.section-nav .next a').index(e.target);
			this.scrollToSection(sectionID+2);
			e.preventDefault();
			return false;
		},
		
		//------------------------------------------------
		// Scroll to previous section
		//------------------------------------------------
		onPreviousButtonClicked:function(e) {
			var sectionID = $('.section-nav .previous a').index(e.target);
			this.scrollToSection(sectionID);
			e.preventDefault();
			return false;
		},
		
		//------------------------------------------------
		// Scroll to selected section
		//------------------------------------------------
		onMainNavClicked:function(e) {
			var sectionID = $('#section-nav a').index(e.target);
			this.scrollToSection(sectionID+1);
			e.preventDefault();
			return false;
		}
	};
	
	return _public;
}());